
def sinc(x)
    x==0 ? 1.0 : Math.sin(x)/x
end

HAMMING_A0 = 25.0/46.0
def hamming(x,n=15)
    HAMMING_A0+(1.0-HAMMING_A0)*Math.cos((2*x*Math::PI)/n)
end

table = []

TABLE_COUNT = 16
TABLE_SIZE = 16
CENTER_OFFSET = 8.0

TABLE_COUNT.times do |i|
    subtab = []
    offset = CENTER_OFFSET-(i.to_f/TABLE_COUNT)
    TABLE_SIZE.times do |j|
        val = (sinc((offset-j)*Math::PI)*hamming(offset-j,TABLE_SIZE-1)*0x7FFF).round
        #puts "#{i} #{j} #{val}"
        subtab << val
    end
    presum = subtab.sum
    # Equalize table (broad)
    offset = 0x7FFF - subtab.sum
    subtab.map!{|x|x+offset/TABLE_SIZE}
    # Equalize table (fine)
    loop do
        sign = (0x7FFF - subtab.sum) <=> 0
        break if sign==0
        subtab[subtab.each_with_index.max_by{|(v,i)|v.abs}[1]] += sign
    end
    offset = 0x7FFF - subtab.sum

    puts "parital #{i} sum: #{subtab.sum} corr: #{subtab.sum - presum}"
    table.concat subtab
end

File.binwrite("SINCPULS.DAT",table.pack('l<*'))
